
type T = int
class Stack
{
    var elems: array<T>;
    var size : nat;
    var capacity: nat;
  
    predicate Valid()
      reads this
    {
      size <= capacity == elems.Length
    }
 
    constructor (cap: nat)
      requires cap > 0
      ensures fresh(elems)
      ensures Valid() && (capacity == cap) && size == 0 
    {
        elems := new T[cap];
        capacity := cap;
        size := 0; 
    
    }
    method isEmpty() returns(res: bool)
      requires Valid()
      ensures Valid() && res == (size == 0)
    {
        return size == 0;
    }

    method  isFull() returns (res:bool)
    requires Valid()
    ensures Valid() && res == (size == elems.Length)
    {
        return size == elems.Length;
    }
    method push(x : T)
      requires Valid() && size < capacity
      modifies this, elems 
      ensures Valid()
      ensures elems[..size] == old(elems[..size]) + [x]
    {
        elems[size] := x;
        size := size + 1;
    
    }
     method top() returns (x: T)
      requires Valid() && size > 0
      ensures x == elems[size-1] && Valid()
    {
        return elems[size-1];
    }
    
    method pop() 
      requires Valid() && size > 0
      modifies this
      ensures Valid() 
      ensures elems[..size] == old(elems[..size-1])
    {
         size := size-1;

  
    }
}

