type T = int // to allow doing new T[capacity], but can be other type 
 
class Stack
{
    const elems: array<T>; 
    var size : nat; // used size
    var capacity: nat;
    constructor (cap: nat)
    requires cap > 0
    ensures fresh(elems)
    ensures Valid() && cap == capacity && size ==0
    {
        elems := new T[cap];
        capacity := cap;
        size := 0; 
    }
    predicate Valid()
    reads this
    { size <= capacity == elems.Length
    }
    predicate method  isEmpty() 
    reads this
    {
        size == 0
    }
 
    predicate method  isFull()
    reads this
    {
        size == elems.Length
    }
 
    method  push(x : T)
    modifies this, elems
    requires Valid() && size < capacity
    {
        elems[size] := x;
        size := size + 1;
    }
 
    function method  top(): T
    requires Valid() && size > 0
    reads this, elems 
    {
         elems[size-1]
    }
    
    method pop() 
    requires Valid() && size > 0
    modifies this
    ensures Valid() 
    ensures elems[..size] == old(elems[..size-1])
    {
         size := size-1;
    }
}
 
// A simple test case.
method {:verify false} Main()
{
    var s := new Stack(3);
    assert s.isEmpty();
    s.push(1);
    s.push(2);
    s.push(3);
    assert s.top() == 3;
    assert s.isFull();
    s.pop();
    assert s.top() == 2;
    print "top = ", s.top(), " \n";
}
